#ifndef FILEBUF__HPP
#define FILEBUF__HPP

#include <ds_streambuf.hpp>

namespace DS_NAMESPACE
{

  class basic_filebufhelper : public streambuf
  {
  public:
    bool closefile;
    FILE *f;

    basic_filebufhelper() : f(0) { }
    virtual ~basic_filebufhelper();
    bool open(const char *f, int flags=0);
    bool open(FILE *file);
    bool close();
    bool is_open();
    streampos pos();
    virtual int flush();
    virtual int seek(const streamoff offs, const ios_base::seek_dir flag);
  };

  class basic_filebuf : public basic_filebufhelper
  {
  public:
    virtual int get();
    virtual int put(const int c);
  };
  
  class basic_wfilebuf : public basic_filebufhelper
  {
  public:
    virtual int get();
    virtual int put(const int c);
  };
  
}

#endif
