#ifndef STREAMBUF__HPP
#define STREAMBUF__HPP

#include <ds_iosbase.hpp>

namespace DS_NAMESPACE
{

  class streambuf
  {
  protected:
    int refcount;
  public:
    streambuf();
    virtual ~streambuf();
    virtual int addref();
    virtual int delref();
    virtual int get() = 0;
    virtual int put(const int c) = 0;
    virtual int seek(const streamoff offs, const ios_base::seek_dir flag) = 0;
    virtual int flush() = 0;
    virtual streampos pos() = 0;

    int ref() const { return refcount; }

    enum { SBEOF = -1000000 };
    static int globalcount;
  };

}

#endif
