#ifndef DS_STRINGSTREAM__HPP
#define DS_STRINGSTREAM__HPP

#include <../ds_istringstream.hpp>
#include <../ds_ostringstream.hpp>

namespace DS_NAMESPACE
{
  template <TYPENAME charT>
  class basic_stringstream : public basic_istringstream<charT>, public basic_ostringstream<charT>
  {
  public:
    basic_stringstream<charT>(const std::basic_string<charT>& s)
    {
      this->str(s);
    }
  };

  typedef basic_stringstream<char> stringstream;
  typedef basic_stringstream<wchar_t> wstringstream;
}

#endif
