#ifndef DS_STRINGSTREAMHELPER__HPP
#define DS_STRINGSTREAMHELPER__HPP

#include <ds_stringbuf.hpp>
#include <string>

namespace DS_NAMESPACE
{
  template <TYPENAME charT, TYPENAME bufT>
  class basic_stringstreamhelper
  {
  protected:
    basic_stringbufhelper<charT> *mysb;
  public:
    basic_stringstreamhelper<charT, bufT>() : mysb(new bufT) { }
    ~basic_stringstreamhelper<charT, bufT>()
    { 
      if(mysb->delref() < 0)
	delete mysb;
    }

    void str(const std::basic_string<charT>& s)
    {
      mysb->str_=s;
      mysb->pos_=0;
    }
    const std::basic_string<charT> str() const { return mysb->str(); }
  };

  struct stringstream_traits_not_implemented { };
  template <TYPENAME charT>
  class stringstream_traits
  {
  public: typedef stringstream_traits_not_implemented sb_t;
  };

  template <>
  class stringstream_traits<char>
  {
  public: typedef basic_stringbuf sb_t;
  };

  template <>
  class stringstream_traits<wchar_t>
  {
  public: typedef basic_wstringbuf sb_t;
  };

}

#endif
